widget_vincentdjango/assignments/urls.py
from django.urls import path
from .views import homeAssignmentsPage, AssignmentsDetailView, AssignmentsUpdateView, AssignmentsCreateView

urlpatterns = [
    path('', homeAssignmentsPage, name='homePage'),
    path('add/', AssignmentsCreateView.as_view(), name='assignment_add'),
    path('<int:pk>/details/', AssignmentsDetailView.as_view(), name='assignment_details'),
    path('<int:pk>/edit/', AssignmentsUpdateView.as_view(), name='assignment_update'),
]

app_name = "assignments"

widget_vincentdjango/dashboard/urls.py
from django.urls import path
from .views import index, UserDetailView, UserCreateView, UserUpdateView


urlpatterns = [
    path('dashboard/', index, name='index'),
    path('widgetusers/<int:pk>/details/', UserDetailView.as_view(), name='user-details'),
    path('widgetusers/add/', UserCreateView.as_view(), name='user-add'),
    path('widgetusers/<int:pk>/edit/', UserUpdateView.as_view(), name='user-edit'),
]


app_name = "dashboard"

widget_vincentdjango/forum/urls.py
# forum/urls.py
from django.urls import path

from .views import index, ForumPostDetailView, ForumPostCreateView, ForumPostUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('forumposts/<int:pk>/details', ForumPostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add', ForumPostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit', ForumPostUpdateView.as_view(), name='forumpost-edit'),
]

# This might be needed, depending on your Django version
app_name = "forum"

widget_vincentdjango/widget_vincentdjango/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('dashboard.urls', namespace="dashboard")),
    path('calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
]

widget_vincentdjango/dashboard/models.py
from django.db import models
from django.urls import reverse

class Department(models.Model):
    dept_name = models.CharField(max_length=100, default="")
    home_unit = models.CharField(max_length=100, default="")

    def __str__(self):
        return '{}, {}'.format(self.dept_name, self.home_unit)


class WidgetUser(models.Model):
    first_name = models.CharField(max_length=50, default="")
    middle_name = models.CharField(max_length=50, default="")
    last_name = models.CharField(max_length=50, default="")
    department = models.ForeignKey(
        Department,
        on_delete=models.CASCADE,
        related_name='User'
    )

    def __str__(self):
        return '{}, {} {}'.format(
            self.last_name,
            self.first_name,
            self.middle_name
        )
    
    def get_absolute_url(self):
        return reverse('dashboard:user-details', kwargs={'pk': self.pk})

widget_vincentdjango/dashboard/forms.py
from django import forms
from .models import WidgetUser

class UserForm(forms.ModelForm):
    
    def __init__(self, *args, **kwargs):
        super(UserForm, self).__init__(*args, **kwargs)
        for visible in self.visible_fields():
            visible.field.widget.attrs['class'] = 'form-design'

    class Meta:
        model = WidgetUser
        fields = '__all__'
        labels = {
            'first_name': ('First Name'),
            'middle_name': ('Middle Name'),
            'last_name': ('Last Name'),
            'department': ('Department, Home Unit'),
        }
        

widget_vincentdjango/dashboard/views.py
from django.shortcuts import render
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from .models import WidgetUser
from .forms import UserForm


def index(request):
        users = WidgetUser.objects.all()
        return render(request, 'dashboard/dashboard.html', {'users': users, })

class UserDetailView(DetailView):
        model = WidgetUser
        template_name = 'dashboard/widgetuser-details.html'

class UserCreateView(CreateView):
        model = WidgetUser
        form_class = UserForm
        template_name = 'dashboard/widgetuser-add.html'

class UserUpdateView(UpdateView):
        model = WidgetUser
        form_class = UserForm
        template_name = 'dashboard/widgetuser-edit.html'

widget_vincentdjango/dashboard/templates/dashboard/dashboard.html
{% extends 'base.html' %}
{% load static %}

{% block style %}{% static 'dashboard/style.css' %}{% endblock %}
{% block title %}Widget v2{% endblock %}
{% block heading %}
    <p>
        <span id="white">Welcome to</span>
        <span id="yellow">Widget!</span>
    </p>
{% endblock %}
{% block content %}
    <div id="main">
        <p id="subheading">Widget Users:</p>
        <ul>
            {% for user in users %}
            <li>
                <a href="{{ user.get_absolute_url }}">
                    {{ user.last_name }}, {{ user.first_name }}</a>
            </li>
            {% endfor %}
        </ul>
    </div>
{% endblock %}
{% block navigation %}
    <div id="btn">
        <button onclick="window.location.href='{% url 'dashboard:user-add' %}';">
            Add Widget User
        </button>
    </div>
    <div id="footer">
        <a href="{% url 'announcements:index' %}">Announcement Board</a>
        <a href="{% url 'forum:index' %}">Forum</a>
        <a href="{% url 'assignments:homePage' %}">Assignments</a>
        <a href="{% url 'widget_calendar:index' %}">Calendar</a>
    </div>
{% endblock %}

widget_vincentdjango/dashboard/templates/dashboard/widgetuser-add.html
{% extends 'base.html' %}
{% load static %}

{% block style %}{% static 'dashboard/formStyle.css' %}{% endblock %}
{% block title %}Add Widget User{% endblock %}
{% block heading %}Add a new Widget User:{% endblock %}
{% block content %}
    <div id="main">
        <img src="{% static 'dashboard/login.png' %}" 
            alt="Facebook login image" width="644" height="234">

        {{ form.non_field_errors }}
        <form action="{% url 'dashboard:user-add' %}" method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div id="btn">
                <input type="submit" value="Add Widget User">
            </div>
        </form>
    </div>
{% endblock %}
{% block navigation %}
    <hr>
    <ul>
        <li><a href="{% url 'dashboard:index' %}">Dashboard</a></li>
        <li>Add Widget User</li>
    </ul>
{% endblock %}

widget_vincentdjango/dashboard/templates/dashboard/widgetuser-details.html
{% extends 'base.html' %}
{% load static %}

{% block style %}{% static 'dashboard/style.css' %}{% endblock %}
{% block title %}{{ object.last_name }}, {{ object.first_name }}{% endblock %}
{% block heading %}
    <p id="uppercase">
        <span id="white">
            {{ object.first_name }} 
            {{ object.middle_name }}
        </span>
        <span id="yellow">
            {{ object.last_name }}
        </span>
    </p>
{% endblock %}
{% block content %}
    <div id="main">
        <p id="subheading"> {{ object.department.dept_name }} </p>
        <p> {{ object.department.home_unit }} </p>
    </div>
{% endblock %}
{% block navigation %}
    <div id="btn">
        <button onclick="window.location.href='{% url 'dashboard:user-edit' pk=object.pk%}';">
            Edit Widget User
        </button>
    </div>
    <ul>
        <li><a href="{% url 'dashboard:index' %}">Dashboard</a></li>
        <li>{{ object.last_name }}, {{ object.first_name }}</li>
    </ul>
{% endblock %}

widget_vincentdjango/dashboard/templates/dashboard/widgetuser-edit.html
{% extends 'base.html' %}
{% load static %}

{% block style %}{% static 'dashboard/formStyle.css' %}{% endblock %}
{% block title %}Edit Widget User{% endblock %}
{% block heading %}Edit Widget User:{% endblock %}
{% block content %}
    <div id="main">
        <img src="{% static 'dashboard/login.png' %}" 
            alt="Facebook login image" width="644" height="234">

        {{ form.non_field_errors }}
        <form action="{% url 'dashboard:user-edit' pk=object.pk %}" method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div id="btn">
                <input type="submit" value="Save Changes to Widget User">
            </div>
        </form>
    </div>
{% endblock %}
{% block navigation %}
    <hr>
    <ul>
        <li><a href="{% url 'dashboard:index' %}">Dashboard</a></li>
        <li>Edit Widget User</li>
    </ul>
{% endblock %}